import { system, world, BlockPermutation, BlockComponentRandomTickEvent } from '@minecraft/server';
import { ChrysalisBlock } from './Chrysalis.js';
function old_chrysalis_update(e) {
	const { block } = e;
	if (!block?.isValid()) return;
	const { typeId } = block;
	const typePref = "sf_nba:chrysalis_stage";
	if (!typeId.startsWith(typePref)) return;
	const stage = parseInt(typeId.slice(typePref.length));
	const direction = block.permutation.getState("minecraft:block_face");
	block.setPermutation(BlockPermutation.resolve(ChrysalisBlock.BLOCK_TYPE, { "minecraft:block_face": direction, "sf_nba:growth_stage": stage }));
}
function check_legacy_chrysalis_list() {
	if (world.getDynamicProperty("sf_nba:chrysalisRegistry") != null)
		world.setDynamicProperty("sf_nba:chrysalisRegistry");
}
system.run(check_legacy_chrysalis_list);
export { old_chrysalis_update }