import { AbstractBucketableEntity as BucketableEntity } from '../entity/AbstractBucketableEntity.js';
import { AnglerfishBuckets } from '../item/AnglerfishBuckets.js';
import { GiantIsopodBuckets } from '../item/GiantIsopodBuckets.js';
import { JellyfishBuckets } from '../item/JellyfishBuckets.js';
import { OctopusBuckets } from '../item/OctopusBuckets.js';
import { PlatypusBuckets } from '../item/PlatypusBuckets.js';
import { RayBuckets } from '../item/RayBuckets.js';
import { SmallJellyfishBuckets } from '../item/SmallJellyfishBuckets.js';
import { StarfishBuckets } from '../item/StarfishBuckets.js';
import { MinecraftLiquid } from '../utils/MinecraftLiquid.js';
new BucketableEntity('sf_nba:anglerfish', AnglerfishBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_anglerfish', fill: 'sf_nba.bucket.fill_anglerfish' }
);
new BucketableEntity('sf_nba:bass', 'sf_nba:bass_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_bass', fill: 'sf_nba.bucket.fill_bass' }
);
new BucketableEntity('sf_nba:blobfish', 'sf_nba:blobfish_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_blobfish', fill: 'sf_nba.bucket.fill_blobfish' }
);
new BucketableEntity('sf_nba:catfish', 'sf_nba:catfish_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_catfish', fill: 'sf_nba.bucket.fill_catfish' }
);
new BucketableEntity('sf_nba:cavefish', 'sf_nba:cavefish_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_cavefish', fill: 'sf_nba.bucket.fill_cavefish' }
);
new BucketableEntity('sf_nba:moray', 'sf_nba:moray_eel_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_eel', fill: 'sf_nba.bucket.fill_eel' }
);
new BucketableEntity('sf_nba:spotted_moray', 'sf_nba:spotted_moray_eel_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_eel', fill: 'sf_nba.bucket.fill_eel' }
);
new BucketableEntity('sf_nba:electric_eel', 'sf_nba:electric_eel_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_eel', fill: 'sf_nba.bucket.fill_eel' }
);
new BucketableEntity('sf_nba:flying_fish', 'sf_nba:flying_fish_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_flying_fish', fill: 'sf_nba.bucket.fill_flying_fish' }
);
new BucketableEntity('sf_nba:giant_isopod', GiantIsopodBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_giant_isopod', fill: 'sf_nba.bucket.fill_giant_isopod' }
);
new BucketableEntity('sf_nba:jellyfish', JellyfishBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'bucket.empty_fish', fill: 'bucket.fill_fish' }
);
new BucketableEntity('sf_nba:octopus', OctopusBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_octopus', fill: 'sf_nba.bucket.fill_octopus' }
);
new BucketableEntity('sf_nba:piranha', 'sf_nba:piranha_bucket', 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_piranha', fill: 'sf_nba.bucket.fill_piranha' }
);
new BucketableEntity('sf_nba:platypus', PlatypusBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_platypus', fill: 'sf_nba.bucket.fill_platypus' }
);
new BucketableEntity('sf_nba:ray', RayBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_ray', fill: 'sf_nba.bucket.fill_ray' }
);
new BucketableEntity('sf_nba:small_jellyfish', SmallJellyfishBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'bucket.empty_fish', fill: 'bucket.fill_fish' }
);
new BucketableEntity('sf_nba:starfish', StarfishBuckets, 'minecraft:water_bucket',
  MinecraftLiquid.FlowingWater, { empty: 'sf_nba.bucket.empty_starfish', fill: 'sf_nba.bucket.fill_starfish' }
);